##
##  scala.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg 2.13.8
%define       V_dist 2.13.8

#   package information
Name:         scala
Summary:      Scala Programming Language
URL:          http://www.scala-lang.org/
Vendor:       Martin Odersky et al.
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        PLUS
Group:        Language
License:      Apache
Version:      %{V_opkg}
Release:      20220115

#   list of sources
Source0:      http://www.scala-lang.org/files/archive/scala-%{V_dist}.tgz
Source1:      scala.c

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101, java, JAVA-JDK

%description
    Scala is a general purpose programming language, which is running on
    the JVM and which is designed to express common programming patterns
    in a concise, elegant, and type-safe way. It smoothly integrates
    features of object-oriented and functional languages. It is also
    fully interoperable with the Java.

%track
    prog scala = {
        version   = %{V_dist}
        url       = https://www.scala-lang.org/download/scala2.html
        regex     = scala-(\d+\.\d+\.\d+(?:\.final)?)\.(tgz|tar\.gz)
    }

%prep
    %setup -q -n scala-%{V_dist}

%build
    rm -f bin/*.bat
    cp %{SOURCE scala.c} .
    %{l_shtool} subst %{l_value -s -a} scala.c
    %{l_cc} %{l_cflags} %{l_ldflags} -o scala scala.c
    %{l_shtool} subst -e 's;/usr/bin/env bash;%{l_bash};g' bin/*

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/lib/scala \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1
    for prog in `find bin -type f -print | sed -e 's;^bin/;;' | grep -v '^scala$'`; do
        ( echo "#!/bin/sh"
          echo "PATH=\"%{l_prefix}/bin:\$PATH\"; export PATH"
          echo "exec %{l_prefix}/lib/scala/bin/$prog \${1+\"\$@\"}"
        ) >$RPM_BUILD_ROOT%{l_prefix}/bin/$prog
        chmod a+x $RPM_BUILD_ROOT%{l_prefix}/bin/$prog
    done
    %{l_shtool} install -c -s -m 755 \
        scala $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 644 \
        man/man1/*.1 $RPM_BUILD_ROOT%{l_prefix}/man/man1/
    cp -rp bin lib \
        $RPM_BUILD_ROOT%{l_prefix}/lib/scala/
    chmod a+x $RPM_BUILD_ROOT%{l_prefix}/lib/scala/bin/*
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

